#include<stdio.h>                         
#include<string.h>
#include<stdlib.h>

char listing = 0;

FILE *infile;
FILE *outfile;

char line[1000];
char qline[1000];
int linenumber;
char string;
char name;
char keyword;
char label;
char constant;
char variable;
int variable0;
int variables;
char quote;
int i, j;
char phrase1[1000];
char phrase2[1000];
char phrase3[1000];
char word1[1000];
char word2[1000];
char word3[1000];
char defineda[30000];
char *definedP;
char *definedv[1000];
int definedc;
char definea[30000];
char *defineP;
char defining;
int labels;
int labeling;
int constants;
int variables;
char *fromP;
char *toP;
int screenc;
int xrefc = 0;
char *filename;

char *xref[] = {
  " %d  %s %s\\n\", UBN_XRF_LINE_LABEL, LN_$, VLSTRING$",
  " %d  %s %s\\n\", UBN_XRF_VARIABLE, LN_$, VLSTRING$",
  " %d  %s %s\\n\", UBN_XRF_VARIABLE, LN_$, VLSTRING$",
  " %d  %s %s\\n\", UBN_XRF_KEYWORD_REFERENCE, LN_$, VLSTRING$",
  " %d  %s %s\\n\", UBN_XRF_LINE_REFERENCE, LN_$, LINE_LABELS$[LINE_LABEL_COUNTER][LINE_LABELS_NUMBER]",
  " %d  %s %s\\n\", UBN_XRF_VARIABLE_REFERENCE, LN_$, VLSTRING$",
  "skip",
  ""
};

char *screenv[] = {
  "q%d %s\\n\", LINE_NUMBER, IN_LINE$",
  "%d %d at %d\\n\", LINE_NUMBER, IN_LINE_CH, IN_LINE_CHAR_COUNTER",
  "%d Too many variables\", LINE_NUMBER",
  "%d Missing end quote - %s\\n\", LINE_NUMBER, QSTRING$",
  "%d '$' should not be used in labels - %s\\n\", LINE_NUMBER, VLSTRING$",
  "%d Too many labels\", LINE_NUMBER",
  "%d Duplicate line label  - %s\\n\", LINE_NUMBER, VLSTRING$",
  "%d Too many variables\", LINE_NUMBER",
  "%d Invalid Octal Number - %s\\n\",LINE_NUMBER, HO_STRING$",
  "%d '&' not followed by 'H' or 'O' - %s\\n\", LINE_NUMBER, HO_STRING$",
  "l%d %s\\n\", LINE_NUMBER, IN_LINE$",
  "qPass %d; %d lines\\n\", PASS, LINE_COUNT",
  "q ---------PASS 2 STARTING------\\n\"",
  "q%s\\n\", UBN_TITLE$",
  "qErrs %d, Warns %d. Lines %d, Labels %d, Vars %d\\n\", ERRORS, WARNINGS, LINE_COUNT, LINE_LABEL_COUNT, VARIABLE_NAMES_COUNT",
  ""
};

char *keywords[] = {
  "REM",
  "ATTR",
  "AUDIO",
  "BACKUP",
  "CIRCLE",
  "CLEAR",
  "CLOAD",
  "CLOADM",
  "CLOSE",
  "CLS",
  "COLOR",
  "CONSTANT",
  "CONT",
  "COPY",
  "CSAVE",
  "CSAVEM",
  "DATA",
  "DEF",
  "DEFUSR",
  "DEL",
  "DIM",
  "DIR",
  "DLOAD",
  "DRAW",
  "DRIVE",
  "DSKI$",
  "DSKINI",
  "DSKO$",
  "EDIT",
  "END",
  "EXEC",
  "FIELD",
  "FILES",
  "FN",
  "FOR",
  "GET",
  "GOSUB",
  "GOTO",
  "HBUFF",
  "HCIRCLE",
  "HCLS",
  "HCOLOR",
  "HDRAW",
  "HGET",
  "HLINE",
  "HPAINT",
  "HPRINT",
  "HPUT",
  "HRESET",
  "HSCREEN",
  "HSET",
  "HSTAT",
  "IF",
  "INPUT",
  "KILL",
  "LET",
  "LINE",
  "LIST",
  "LLIST",
  "LOCATE",
  "LPOKE",
  "LOAD",
  "LOADM",
  "LSET",
  "MERGE",
  "MOTOR",
  "NEW",
  "NEXT",
  "OLD",
  "ON",
  "OPEN",
  "PAINT",
  "PALETTE",
  "PCLEAR",
  "PCLS",
  "PCOPY",
  "PLAY",
  "PMODE",
  "POKE",
  "PRESET",
  "PRINT",
  "PSET",
  "PUT",
  "READ",
  "RENAME",
  "RENUM",
  "RESET",
  "RSET",
  "RESTORE",
  "RESUME",
  "RETURN",
  "RUN",
  "SAVE",
  "SAVEM",
  "SCREEN",
  "SET",
  "SKIPF",
  "SOUND",
  "STOP",
  "TO",
  "TROFF",
  "TRON",
  "WIDTH",
  "WRITE",
  "UNLOAD",
  "VERIFY",
  "MEM",
  "TIMER",
  "AND",
  "NOT",
  "OR",
  "ELSE",
  "STEP",
  "FREE",
  "AS",
  "BRK",
  "ERR",
  "CMP",
  "RGB",
  "USING",
  "ERROR",
  "FREE",
  "OFF",
  "TAB",
  "USING",
  "THEN",
  "TO",
  "?",
  "AS",
  "OR",
  "PI",

/* Functions, keywords that require next character to be an open parentheses*/

  "ABS",
  "ASC",
  "ATN",
  "BUTTON",
  "CHR$",
  "COS",
  "CVN",
  "EOF",
  "ERLIN",
  "ERNO",
  "EXP",
  "FIX",
  "HEX$",
  "HPOINT",
  "INKEY$",
  "INSTR",
  "INT",
  "JOYSTK",
  "LEFT$",
  "LEN",
  "LOC",
  "LOF",
  "LOG",
  "LPEEK",
  "MID$",
  "MKN$",
  "PEEK",
  "POINT",
  "POS",
  "PPOINT",
  "RIGHT$",
  "RND",
  "SGN",
  "SIN",
  "STRING$",
  "STR$",
  "SQR",
  "TAN",
  "USR",
  "VAL",
  "VARPTR",
  ""
};


/* Illegal Two Character Variable Table */
/* NOTE "PI" is a variable that is NOT replaced */

char *illegal[] = {
  "BF",
  "AS",
  "FN",
  "IF",
  "ON",
  "OR",
  "PI",
  "TO",
  ""
};

int error(char *mesg) {
  printf("%d %s %s", linenumber, mesg, line);
  exit(0);
}

char *skip2colon(char *lineP) {
  while (*lineP && *lineP!=':')  lineP++;
  return lineP;
}

char islabelchar(char intch) {
  if (intch=='_' || (intch>='A' && intch<='Z'))  return 1;
  if (intch>='0' && intch<='9')  return 1;
  return 0;
}

char isin(char *word, char **table) {
  int i=0;
  while (table[i][0]) {
    if (!strcmp(word, table[i]))  break;
    i++;
  }
  if (table[i][0])  return 1;
  return  0;
}

char *copyword(char *wordP, char *lineP) {
  while (*wordP)
    *lineP++ = *wordP++;
  *lineP = 0;
  return lineP;
}

char *getword(char *wordP, char *lineP) {
  char *word;
  int i;
  if (*lineP==' ')  lineP++;
  word = wordP;
  if (*lineP=='"') {
    *wordP++ = *lineP++;
    while (*lineP && *lineP!='"')  *wordP++ = *lineP++;
    if (*lineP=='"')  *wordP++ = *lineP++;
    *wordP = 0;
    string = 1;
    constant = 1;
    keyword = 0;
    name = 0;
    label = 0;
    variable = 0;
    return lineP;
  }
  if (islabelchar(*lineP))  name = 1;
  if (*lineP>='0' && *lineP<='9')  name = 0;
  while (*lineP && *lineP!=' ' && *lineP!='(' && *lineP!=',' && *lineP!=')') {
    if (!islabelchar(*lineP) && *lineP!='$' && *lineP!='~' &&
        !(*lineP>='a' && *lineP<='z'))  name = 0;
    *wordP++ = *lineP++;
  }
  if (word==wordP) {
    name = 0;
    if (*lineP)  *wordP++ = *lineP++;
  }
  *wordP = 0;
  if (word!=wordP && *(wordP-1)=='$')  string = 1;
  else  string = 0;
  label = 0;
  constant = 0;
  variable = 0;
  keyword = isin(word, keywords);
  if (keyword)  return lineP;
  if (!name) return lineP;
  i = 0;
  while (definedv[i][0] && strcmp(word, definedv[i]))  i++;
  if (i<labels)  label = 1;
  else if (i<constants)  constant=1;
  else variable = 1;
  if (i>=definedc) {
    definedv[definedc++] = definedP;
    definedv[definedc] = "";
    definedP = copyword(word, definedP);
    *definedP++ = 0;
    if (defining)  return lineP;
    if (string) {
      if (!strcmp(word, "IN_LINE$"))
        fprintf(outfile, "char %s[300];\n", word);
      else fprintf(outfile, "char %s[300];\n", word);
    }
    else fprintf(outfile, "int %s;\n", word);
  }
  return lineP;
}

char *copylabel(FILE *outfile, char *lineP) {
  char word[1000];
  lineP = getword(word, lineP);
  fprintf(outfile, word);
  return lineP;
}

char *getphrase(char *phraseP, char *lineP) {
  char stringtype;
  char *charP;
  char word[1000];
  char stack[1000];
  char *stackP;
  stackP = stack;
  *stackP = 0;
  if (!*lineP)  error("empty phrase");
  charP = getword(word, lineP);
  stringtype = string;
  if (!name && !constant)  error("not name in phrase");
  do {
    if (!strcmp(word, "(")) {
      *phraseP++ = '[';
      *++stackP = ']';
    }
    else if (!strcmp(word, "MID$"))  {
      phraseP = copyword("mid$(temp$,", phraseP);
      charP = getword(word, charP);
      *++stackP = 'f';
    }
    else if (!strcmp(word, ",")) {
      if (*stackP=='f') {
        phraseP = copyword(", ", phraseP);
        *stackP = 's';
      }
      else if (*stackP=='s') {
        phraseP = copyword(", ", phraseP);
        *stackP = ')';
      }
      else phraseP = copyword("][", phraseP);
    }
    else if (!strcmp(word, ")")) {
      if (*stackP=='s') {
        phraseP = copyword(", 0)", phraseP);
        stackP--;
      }
      else  *phraseP++ = *stackP--;
    }
    else if (!strcmp(word, "ASC") || !strcmp(word, "CHR$")
        || !strcmp(word, "LEN")) {
      if (!strcmp(word, "ASC"))  phraseP = copyword("asc", phraseP);
      else if (!strcmp(word, "CHR$"))  phraseP = copyword("chr$", phraseP);
      else if (!strcmp(word, "LEN"))  phraseP = copyword("len", phraseP);
      charP = getword(word, charP);
      phraseP = copyword(word, phraseP);
      *++stackP = ')';
    }
    else {
      if (keyword)  error("keyword in phrase");
      phraseP = copyword(word, phraseP);
    }
    *phraseP = 0;
    lineP = charP;
    charP = getword(word, lineP);
  }
  while (*stackP || !strcmp(word, "("));
  *phraseP = 0;
  string = stringtype;
  return lineP;
}

int main(int argc, char **argv) {

  int intch;
  char eol;
  char *lineP;
  char *oldlineP;
  char ch;
  char *charP;
  int returns;
  int fors;
  int forvar;
  int parens;
  char skipsemi = 0;
  char brace = 0;

  if (argc==2)  filename=argv[2];
  else filename = "ubn_in.txt";
  infile = fopen(filename, "r");
  outfile = fopen("urbane.c", "w");

  fprintf(outfile, "#include<stdio.h>\n");
  fprintf(outfile, "#include<stdlib.h>\n");
  fprintf(outfile, "#include<string.h>\n\n");

  /* collect labels */

  definedP = definea;
  definedc = 0;
  definedv[0] = "";
  defining = 1;
  linenumber = 0;
  intch = fgetc(infile);
  while (intch!=EOF) {
    linenumber++;
    eol = 0;
    charP = line;
    while (!eol) {
      if (intch==EOF || intch=='\r' || intch=='\n') {
        eol = 1;
        *charP = 0;
        if (intch=='\r') {
          intch = fgetc(infile);
          if (intch=='\n')  intch=fgetc(infile);
        }
        else if (intch=='\n')  intch=fgetc(infile);
      }
      else if (intch=='\"') {
        do {
          *charP++ = intch;
          intch = fgetc(infile);
        }
        while (intch!=EOF && intch!='\r' && intch!='\n' && intch!='\"');
        if (intch=='\"') {
          *charP++ = intch;
          intch = fgetc(infile);
        }
      }
      else if (intch==' ' || intch=='\t') {
        *charP++ = ' ';
        do {
          intch = fgetc(infile);
        }
        while (intch==' ' || intch=='\t');
      }
      else {
        *charP++ = intch;
        intch = fgetc(infile);
      }
    }
    if (islabelchar(line[0]))  getword(word1, line);
  }

  labels = definedc;

  /* collect constants */

  fclose(infile);
  infile = fopen(filename, "r");
  linenumber = 0;
  intch = fgetc(infile);
  while (intch!=EOF) {
    linenumber++;
    eol = 0;
    charP = line;
    while (!eol) {
      if (intch==EOF || intch=='\r' || intch=='\n') {
        eol = 1;
        *charP = 0;
        if (intch=='\r') {
          intch = fgetc(infile);
          if (intch=='\n')  intch=fgetc(infile);
        }
        else if (intch=='\n')  intch=fgetc(infile);
      }
      else if (intch=='\"') {
        do {
          *charP++ = intch;
          intch = fgetc(infile);
        }
        while (intch!=EOF && intch!='\r' && intch!='\n' && intch!='\"');
        if (intch=='\"') {
          *charP++ = intch;
          intch = fgetc(infile);
        }
      }
      else if (intch==' ' || intch=='\t') {
        *charP++ = ' ';
        do {
          intch = fgetc(infile);
        }
        while (intch==' ' || intch=='\t');
      }
      else {
        *charP++ = intch;
        intch = fgetc(infile);
      }
    }
    if (line[0]=='\'')  fprintf(outfile, "/*%s */\n", line+1);
    ch = line[11];
    line[11] = 0;
    if (!strcmp(line, "# LIST_ON :"));
    else if (!strcmp(line, "# XREF_ON :"));
    else {
      if (!strcmp(line, "# CONSTANT ")) {
        fprintf(outfile, "#define ");
        line[11] = ch;
        lineP = line+11;
        charP = getword(word1, lineP);
        if (!strcmp(word1, "UBN_MEM_LINE_LABEL_MAX_COUNT"))
          fprintf(outfile, "%s %s", word1, "10000");
        else if (!strcmp(word1, "UBN~VERSION$")) {
          fprintf(outfile, "UBN_VERSION$ %s", charP+3);
          for (lineP=charP+3, charP=word2; *lineP; lineP++)
            if (*lineP!='"')  *charP++ = *lineP;
          *charP = 0;
        }
        else if (!strcmp(word1, "UBN_TITLE$"))
          fprintf(outfile,
              "UBN_TITLE$ \"Urbane %s CoCo Preprocessor.\"", word2);
        else if (!strcmp(word1, "UBN_XREF_LIST_INITIAL") ||
            !strcmp(word1, "UBN_LIST_LIST_INITIAL")) {
          line[11] = ch;
          line[33] = 0;
          fprintf(outfile, "%s0", lineP);
        }
        else {
          lineP = getword(word1, lineP);
          fprintf(outfile, "%s ", word1);
          if (*lineP!=' ' || *(lineP+1)!='=' || *(lineP+2)!=' ')
            error("define =");
          if (!strcmp(word1, "ASC_TAB"))  fprintf(outfile, "\'\\t\'");
          else {
            ch = *(lineP+16);
            *(lineP+16) = 0;
            if (!strcmp(lineP+5, " : REM ASC(")) {
              if (*(lineP+17)=='\'') fprintf(outfile, "\'\\\'\'");
              else {
                fputc('\'', outfile);
                fputc(*(lineP+17), outfile);
                fputc('\'', outfile);
              }
            }
            else if (!strcmp(lineP+6, " : REM ASC")) {
              fputc('\'', outfile);
              fputc(*(lineP+18), outfile);
              fputc('\'', outfile);
            }
            else {
              *(lineP+16) = ch;
              fprintf(outfile, lineP+3);
            }
          }
        }
      }
      if (line[0]!='\'')  putc('\n', outfile);
      if (!strcmp(word1, "UBN_XRF_KEYWORD_REFERENCE")) {
        constants = definedc;
        break;
      }
    }
  }
  fputc('\n', outfile);

  /* define DIM's */

  fclose(infile);
  infile = fopen(filename, "r");
  linenumber = 0;
  intch = fgetc(infile);
  while (intch!=EOF) {
    linenumber++;
    eol = 0;
    charP = line;
    while (!eol) {
      if (intch==EOF || intch=='\r' || intch=='\n') {
        eol = 1;
        *charP = 0;
        if (intch=='\r') {
          intch = fgetc(infile);
          if (intch=='\n')  intch=fgetc(infile);
        }
        else if (intch=='\n')  intch=fgetc(infile);
      }
      else if (intch=='\"') {
        do {
          *charP++ = intch;
          intch = fgetc(infile);
        }
        while (intch!=EOF && intch!='\r' && intch!='\n' && intch!='\"');
        if (intch=='\"') {
          *charP++ = intch;
          intch = fgetc(infile);
        }
      }
      else if (intch==' ' || intch=='\t') {
        *charP++ = ' ';
        do {
          intch = fgetc(infile);
        }
        while (intch==' ' || intch=='\t');
      }
      else {
        *charP++ = intch;
        intch = fgetc(infile);
      }
    }
    lineP = line;
    if (islabelchar(line[0]))  lineP = getword(word1, lineP);
    if (lineP[1]=='D' && lineP[2]=='I' && lineP[3]=='M' && lineP[4]==' ') {
      getphrase(phrase1, lineP+4);
      fprintf(outfile, "char %s[100];\n", phrase1);
    }
  }


  /* skip constants */

  fclose(infile);
  infile = fopen(filename, "r");
  linenumber = 0;
  intch = fgetc(infile);
  while (intch!=EOF) {
    linenumber++;
    eol = 0;
    charP = line;
    while (!eol) {
      if (intch==EOF || intch=='\r' || intch=='\n') {
        eol = 1;
        *charP = 0;
        if (intch=='\r') {
          intch = fgetc(infile);
          if (intch=='\n')  intch=fgetc(infile);
        }
        else if (intch=='\n')  intch=fgetc(infile);
      }
      else if (intch=='\"') {
        do {
          *charP++ = intch;
          intch = fgetc(infile);
        }
        while (intch!=EOF && intch!='\r' && intch!='\n' && intch!='\"');
        if (intch=='\"') {
          *charP++ = intch;
          intch = fgetc(infile);
        }
      }
      else if (intch==' ' || intch=='\t') {
        *charP++ = ' ';
        do {
          intch = fgetc(infile);
        }
        while (intch==' ' || intch=='\t');
      }
      else {
        *charP++ = intch;
        intch = fgetc(infile);
      }
    }
    if (!strcmp(line, "# CONSTANT UBN_XRF_KEYWORD_REFERENCE = 8"))  break;
  }

  /* define variables */

  defining = 0;
  variable0 = definedc;
  while (intch!=EOF) {
    linenumber++;
    eol = 0;
    charP = line;
    while (!eol) {
      if (intch==EOF || intch=='\r' || intch=='\n') {
        eol = 1;
        *charP = 0;
        if (intch=='\r') {
          intch = fgetc(infile);
          if (intch=='\n')  intch=fgetc(infile);
        }
        else if (intch=='\n')  intch=fgetc(infile);
      }
      else if (intch=='\"') {
        do {
          *charP++ = intch;
          intch = fgetc(infile);
        }
        while (intch!=EOF && intch!='\r' && intch!='\n' && intch!='\"');
        if (intch=='\"') {
          *charP++ = intch;
          intch = fgetc(infile);
        }
      }
      else if (intch==' ' || intch=='\t') {
        *charP++ = ' ';
        do {
          intch = fgetc(infile);
        }
        while (intch==' ' || intch=='\t');
      }
      else {
        *charP++ = intch;
        intch = fgetc(infile);
      }
    }
    lineP = line;
    while (*lineP) {
      if (*lineP=='\'')  break;
      lineP=getword(word1, lineP);
      if (!strcmp(word1, "DATA"))  break;
      if (!strcmp(word1, "REM"))  break;
    }
  }
  variables = definedc;

  char *between[] = {
"",
"char label = 0;",
"char tron = 0;",
"char echo = 0;",
"char debug = 0;",
"char quiet = 1;",
"char list = 0;",
"char errors = 0;",
"int intchar;",
"",
"char *datav[] = {",
"  \"REM\",",
"  \"ATTR\",",
"  \"AUDIO\",",
"  \"BACKUP\",",
"  \"CIRCLE\",",
"  \"CLEAR\",",
"  \"CLOAD\",",
"  \"CLOADM\",",
"  \"CLOSE\",",
"  \"CLS\",",
"  \"COLOR\",",
"  \"CONSTANT\",",
"  \"CONT\",",
"  \"COPY\",",
"  \"CSAVE\",",
"  \"CSAVEM\",",
"  \"DATA\",",
"  \"DEF\",",
"  \"DEFUSR\",",
"  \"DEL\",",
"  \"DIM\",",
"  \"DIR\",",
"  \"DLOAD\",",
"  \"DRAW\",",
"  \"DRIVE\",",
"  \"DSKI$\",",
"  \"DSKINI\",",
"  \"DSKO$\",",
"  \"EDIT\",",
"  \"END\",",
"  \"EXEC\",",
"  \"FIELD\",",
"  \"FILES\",",
"  \"FN\",",
"  \"FOR\",",
"  \"GET\",",
"  \"GOSUB\",",
"  \"GOTO\",",
"  \"HBUFF\",",
"  \"HCIRCLE\",",
"  \"HCLS\",",
"  \"HCOLOR\",",
"  \"HDRAW\",",
"  \"HGET\",",
"  \"HLINE\",",
"  \"HPAINT\",",
"  \"HPRINT\",",
"  \"HPUT\",",
"  \"HRESET\",",
"  \"HSCREEN\",",
"  \"HSET\",",
"  \"HSTAT\",",
"  \"IF\",",
"  \"INPUT\",",
"  \"KILL\",",
"  \"LET\",",
"  \"LINE\",",
"  \"LIST\",",
"  \"LLIST\",",
"  \"LOCATE\",",
"  \"LPOKE\",",
"  \"LOAD\",",
"  \"LOADM\",",
"  \"LSET\",",
"  \"MERGE\",",
"  \"MOTOR\",",
"  \"NEW\",",
"  \"NEXT\",",
"  \"OLD\",",
"  \"ON\",",
"  \"OPEN\",",
"  \"PAINT\",",
"  \"PALETTE\",",
"  \"PCLEAR\",",
"  \"PCLS\",",
"  \"PCOPY\",",
"  \"PLAY\",",
"  \"PMODE\",",
"  \"POKE\",",
"  \"PRESET\",",
"  \"PRINT\",",
"  \"PSET\",",
"  \"PUT\",",
"  \"READ\",",
"  \"RENAME\",",
"  \"RENUM\",",
"  \"RESET\",",
"  \"RSET\",",
"  \"RESTORE\",",
"  \"RESUME\",",
"  \"RETURN\",",
"  \"RUN\",",
"  \"SAVE\",",
"  \"SAVEM\",",
"  \"SCREEN\",",
"  \"SET\",",
"  \"SKIPF\",",
"  \"SOUND\",",
"  \"STOP\",",
"  \"TO\",",
"  \"TROFF\",",
"  \"TRON\",",
"  \"WIDTH\",",
"  \"WRITE\",",
"  \"UNLOAD\",",
"  \"VERIFY\",",
"  \"MEM\",",
"  \"TIMER\",",
"  \"AND\",",
"  \"NOT\",",
"  \"OR\",",
"  \"ELSE\",",
"  \"STEP\",",
"  \"FREE\",",
"  \"AS\",",
"  \"BRK\",",
"  \"ERR\",",
"  \"CMP\",",
"  \"RGB\",",
"  \"USING\",",
"  \"ERROR\",",
"  \"FREE\",",
"  \"OFF\",",
"  \"TAB\",",
"  \"USING\",",
"  \"THEN\",",
"  \"TO\",",
"  \"?\",",
"  \"AS\",",
"  \"OR\",",
"  \"PI\",",
"",
"  \"ABS\",",
"  \"ASC\",",
"  \"ATN\",",
"  \"BUTTON\",",
"  \"CHR$\",",
"  \"COS\",",
"  \"CVN\",",
"  \"EOF\",",
"  \"ERLIN\",",
"  \"ERNO\",",
"  \"EXP\",",
"  \"FIX\",",
"  \"HEX$\",",
"  \"HPOINT\",",
"  \"INKEY$\",",
"  \"INSTR\",",
"  \"INT\",",
"  \"JOYSTK\",",
"  \"LEFT$\",",
"  \"LEN\",",
"  \"LOC\",",
"  \"LOF\",",
"  \"LOG\",",
"  \"LPEEK\",",
"  \"MID$\",",
"  \"MKN$\",",
"  \"PEEK\",",
"  \"POINT\",",
"  \"POS\",",
"  \"PPOINT\",",
"  \"RIGHT$\",",
"  \"RND\",",
"  \"SGN\",",
"  \"SIN\",",
"  \"STRING$\",",
"  \"STR$\",",
"  \"SQR\",",
"  \"TAN\",",
"  \"USR\",",
"  \"VAL\",",
"  \"VARPTR\",",
"  \"\\\\\",",
"  \"BF\",",
"  \"AS\",",
"  \"FN\",",
"  \"IF\",",
"  \"ON\",",
"  \"OR\",",
"  \"PI\",",
"  \"TO\",",
"  \"\\\\\"",
"};",
"",
"char *notkeyword[] = {",
"  \"G\",",
"  \"BF\",",
"  \"B\",",
"  \"R\",",
"  \"PI\",",
"  \"\\\\\"",
"};",
"",
"int i;",
"char eof = 0;",
"int intch = 0;",
"int datac = 0;",
"int back;",
"int forvar;",
"int switcher;",
"char temp$[300];",
"char chrs$[256][2];",
"char qline$[1000];",
"char *qlineP$;",
"int *tempP;",
"char *fileoutname;",
"char gotogosub = 0;",
"char thenelse = 0;",
"char run = 0;",
"char needrem = 0;",
"char data = 0;",
"char hadlabel = 0;",
"char juststarted = 0;",
"char labeling = 0;",
"char hasalabel = 0;",
"",
"FILE *file_i;",
"FILE *file_o;",
"FILE *file_e;",
"FILE *file_l;",
"FILE *file_x;",
"FILE *bug;",
"",
"char *str$(int number) {",
"  int i=0;",
"  int divisor=10000;",
"  int quotient;",
"  char some=0;",
"  while (divisor) {",
"    quotient = number/divisor;",
"    if (some || quotient || divisor==1) {",
"      some = 1;",
"      LNR_$[i++] = quotient+'0';",
"    }",
"    number = number-quotient*divisor;",
"    divisor = divisor/10;",
"  }",
"  LNR_$[i] = 0;",
"  return LNR_$;",
"}",
"",
"char join(int linenumber, char *to, char *first, char *second) {",
"  char *toP = to;",
"  char *firstP = first;",
"  char *secondP = second;",
"  int i = 0;",
"  char *mesg;",
"  mesg = \"\";",
"  if (to==second)  mesg = \"string order\";",
"  while ((*toP++ = *firstP++))  i++;",
"  toP--;",
"  while ((*toP++ = *secondP++))  if (i++>256)  break;",
"  if (i<257)  return 0;",
"  if (!mesg[0])  mesg = \"string overflow\";",
"  if (!list || !quiet) ",
"    printf(\" %d %s %s\\n%s\", linenumber, mesg, first, second);",
"  return 1;",
"}",
"",
"char let(int linenumber, char *to, char *from) {",
"  return join(linenumber, to, from, \"\");",
"}",
"",
"void labelerror(char *mesg) {",
"  char *charP;",
"  if (strcmp(mesg, \"label\") && strcmp(mesg, \"number\")) {",
"    if (!list || !quiet) ",
"      printf(\" %d %s - %s\\n\", LINE_NUMBER, mesg, VLSTRING$) ;",
"    fprintf(file_e, \"%d %s - %s\\n\", LINE_NUMBER, mesg, VLSTRING$) ;",
"    ERRORS++;",
"  }",
"  charP = IN_LINE$+IN_LINE_CHAR_COUNTER-1;",
"  while (*charP==' ')  charP++;",
"  if (gotogosub)",
"    if (*charP!=',')",
"      gotogosub=0;",
"  if (thenelse)  gotogosub=0;",
"  needrem = thenelse = run = 0;",
"  hadlabel = 1;",
"}",
"",
"void report(char *mesg) {",
"  if (juststarted) {",
"    if (!list || !quiet) ",
"      printf(\" %d %s at start of line\\n\", LINE_NUMBER, mesg) ;",
"    fprintf(file_e, \"%d %s at start of line\\n\", LINE_NUMBER, mesg) ;",
"    ERRORS++;",
"  }",
"  juststarted = 0;",
"}",
"",
"char iskeyword(char *name) {",
"  int i;",
"  i = 0;",
"  while (strcmp(datav[i], \"\\\\\")) {",
"    if (!strcmp(datav[i], name))  break;",
"    i++;",
"  }",
"  if (strcmp(datav[i], \"\\\\\")) {",
"    return 1;",
"  }",
"  return 0;",
"}",
"",
"char islabel(char *VLSTRING$) {",
"  for (LINE_LABEL_COUNTER = LINE_LABEL_START;",
"      LINE_LABEL_COUNTER<=LINE_LABEL_COUNT; LINE_LABEL_COUNTER++)",
"    if (!strcmp(VLSTRING$,",
"          LINE_LABELS$[LINE_LABEL_COUNTER][LINE_LABELS_NAME]))",
"      break;",
"  return LINE_LABEL_COUNTER<=LINE_LABEL_COUNT;",
"}",
"",
"void havevariable() {",
"  needrem = juststarted = 0;",
"  if (gotogosub || run)  labelerror (\"undefined label\") ;",
"  thenelse = 0;",
"}",
"",
"void havenumber() {",
"  report(\"number\");",
"  if (gotogosub || thenelse || (run && !islabel(VLSTRING$))) {",
"    labelerror (\"undefined label\") ;",
"    thenelse = 0;",
"  }",
"}",
"",
"void havelabel() {",
"  if (!gotogosub && !thenelse && !run && islabel(VLSTRING$)) {",
"    if (!list || !quiet) ",
"      printf(\" %d bad label use - %s\\n\", LINE_NUMBER, VLSTRING$) ;",
"    fprintf(file_e, \"%d bad label use - %s\\n\", LINE_NUMBER, VLSTRING$) ;",
"    ERRORS++;",
"  }",
"  labelerror(\"label\");",
"}",
"",
"void havekeyword () {",
"  if (!iskeyword(VLSTRING$)) {",
"    if (islabel(VLSTRING$))  havelabel();",
"    else  havevariable();",
"  }",
"  else {",
"    needrem = juststarted = 0;",
"    if (run || gotogosub)  labelerror(\"keyword instead of label\");",
"    else if (!data) {",
"      if (!strcmp(VLSTRING$, \"DATA\"))  {",
"        data = 1;",
"        gotogosub = thenelse = run = 0;",
"      }",
"      else if (thenelse) {",
"        if (!strcmp(VLSTRING$, \"GOTO\"))  gotogosub=1;",
"        else if (!strcmp(VLSTRING$, \"GOSUB\"))  gotogosub=1;",
"        else if (!strcmp(VLSTRING$, \"RUN\")) {",
"          run=1;",
"          thenelse = 0;",
"        }",
"        else  thenelse = 0;",
"      }",
"      else {",
"        if (!strcmp(VLSTRING$, \"GOTO\") || !strcmp(VLSTRING$, \"GOSUB\")) {",
"          gotogosub = 1;",
"          hadlabel = 0;",
"        }",
"        if (!strcmp(VLSTRING$, \"RUN\"))  run=1;",
"        if (!strcmp(VLSTRING$, \"THEN\"))  thenelse=1;",
"        if (!strcmp(VLSTRING$, \"ELSE\"))  thenelse=1;",
"      }",
"    }",
"  }",
"}",
"",
"void havechar() {",
"  if (labeling) {",
"    if (IN_LINE_CH==' ') {",
"      juststarted = 1;",
"      labeling = 0;",
"    }",
"  }",
"  if (juststarted && IN_LINE_CH!=' ') {",
"    report(\"not keyword or variable\");",
"  }",
"  if (gotogosub) {",
"    if (!hadlabel && IN_LINE_CH==',' && IN_LINE_CH!=' ') {",
"      if (!list || !quiet) ",
"        printf(\" %d missing label after %s\\n\", LINE_NUMBER, VLSTRING$) ;",
"      fprintf(file_e, \"%d missing label after %s\\n\", LINE_NUMBER, VLSTRING$) ;",
"      ERRORS++;",
"    }",
"    else if ((IN_LINE_CH!=',' && IN_LINE_CH!=' ') ||",
"        (!hadlabel && IN_LINE_CH!=' ')) {",
"      if (!list || !quiet) ",
"        printf(\" %d bad character %s after %s\\n\",",
"          LINE_NUMBER, IN_LINE_CH$, VLSTRING$) ;",
"      fprintf(file_e, \"%d bad character %s after %s\\n\",",
"          LINE_NUMBER, IN_LINE_CH$, VLSTRING$) ;",
"      ERRORS++;",
"      if (IN_LINE_CH!=',')  gotogosub = 0;",
"      thenelse = run = 0;",
"    }",
"    if (IN_LINE_CH==',')  hadlabel = 0;",
"  }",
"}",
"",
"void nextline() {",
"  data = 0;",
"  if (gotogosub || thenelse) {",
"    if (!list || !quiet) ",
"      printf(\" %d missing label at eol\\n\", LINE_NUMBER-1);",
"    fprintf(file_e, \"%d missing label at eol\\n\", LINE_NUMBER-1);",
"    ERRORS++;",
"  }",
"  gotogosub = thenelse = run = 0;",
"}",
"",
"char error(char *mesg) {",
"  if (!list || !quiet)  printf(mesg);",
"  fprintf(bug, mesg);",
"  return 0;",
"}",
"",
"void parse(int argc, char **argv) {",
"  for (i=2; i<argc; i++) {",
"    if (!strcmp(argv[i], \"-x\"))  OUTPUT_XREF = TRUE;",
"    if (!strcmp(argv[i], \"-v\"))  quiet = FALSE;",
"    if (!strcmp(argv[i], \"-l\")) {",
"      OUTPUT_LISTING = TRUE;",
"      list = TRUE;",
"    }",
"    if (argv[i][0]=='-' && argv[i][1]=='o' && argv[i][2]=='=')",
"      fileoutname = argv[i]+3;",
"    if (argv[i][0]=='-' && argv[i][1]=='e' && argv[i][2]=='=')",
"      file_e = fopen(argv[i]+3, \"w\");",
"    if (argv[i][0]=='-' && argv[i][1]=='l' && argv[i][2]=='=') {",
"      file_l = fopen(argv[i]+3, \"w\");",
"    }",
"    if (argv[i][0]=='-' && argv[i][1]=='x' && argv[i][2]=='=') {",
"      OUTPUT_XREF = TRUE;",
"      file_x = fopen(argv[i]+3, \"w\");",
"    }",
"  }"
"  OUTPUT_LISTING = TRUE;",
"}",
"",
"",
"int instr(char *in_line, char *word) {",
"  int len;",
"  char *fromP;",
"  char *toP;",
"  char line[300];",
"  fromP = in_line;",
"  toP = line;",
"  while ((*toP++ = *fromP++));",
"  len = strlen(word);",
"  for (i=strlen(line)-len; i>0; i--) {",
"    line[i+len] = 0;",
"    if (!strcmp(word, line+i))  break;",
"  }",
"  return i;",
"}",
"",
"void input(char *in_line) {",
"  char *charP;",
"  char name[1000];",
"  char *nameP;",
"  char eol = 0;",
"  if (intchar==EOF)  eof=NUM_M1;",
"  charP = in_line;",
"  while (!eol && !eof) {",
"    if (intchar==EOF || intchar=='\\n' || intchar=='\\r') {",
"      eol = 1;",
"      if (intchar=='\\r') {",
"        intchar = fgetc(file_i);",
"        if (intchar=='\\n')",
"          intchar = fgetc(file_i);",
"      }",
"      else if (intchar=='\\n')",
"        intchar = fgetc(file_i);",
"    }",
"    else {",
"      *charP++ = intchar;",
"      intchar = fgetc(file_i);",
"    }",
"  }",
"  *charP = 0;",
"  charP = in_line;",
"  if ((*charP>='0' && *charP<='9') || (*charP>='a' && *charP<='z') ||",
"      (*charP>='A' && *charP<='Z') || *charP=='_')  hasalabel = 1;",
"  else  hasalabel = 0;",
"  nameP = name;",
"  if (*charP)  *nameP++ = *charP++;",
"  while (*charP) {",
"    if ((*charP>='A' && *charP<='Z') ||",
"        (*charP>='a' && *charP<='z') ||",
"        (*charP>='0' && *charP<='9') || *charP=='_')",
"      *nameP++ = *charP++;",
"    else  break;",
"  }",
"  *nameP = 0;",
"  if (PASS==2 && hasalabel && iskeyword(name)) {",
"    if (!list || !quiet) ",
"      printf(\" %d keyword as line label - %s\\n\", LINE_NUMBER, name) ;",
"    ERRORS++;",
"  }",
"  if (hasalabel) {",
"    needrem = 1;",
"    labeling = 1;",
"    juststarted = 0;",
"  }",
"  else if (name[0]==' ') {",
"    needrem = 0;",
"    labeling = 0;",
"    juststarted = 1;",
"  }",
"  else {",
"    needrem = 0;",
"    labeling = 0;",
"    juststarted = 0;",
"  }",
"}",
"",
"char outputrem() {",
"/* if (LINE_NUMBER==204)  tron = 1; */",
"  if (IN_LINE_CH==NUM_M1 && PASS==NUM_2) {",
"    let (1, OUTPUT_STRING$, str$(LINE_NUMBER));",
"    join(1, OUTPUT_STRING$, OUTPUT_STRING$, \" REM\");",
"    return 1;",
"  }",
"  return 0;",
"}",
"",
"int asc(char *string) {",
"  return string[0];",
"}",
"",
"char *chr$(int val) {",
"  return chrs$[val];",
"}",
"",
"int len(char *name) {",
"  int i = 0;",
"  while (name[i]) i++;",
"  return i;",
"}",
"",
"char *mid$(char * toP, char *fromP, int begin, int length) {",
"  let(0, toP, fromP+begin-1);",
"  if (length)  toP[length] = 0;",
"  return toP;",
"}",
"",
"char *showquotes(char *fromP) {",
"  char *toP;",
"  toP = qline$;",
"  while (*fromP) {",
"    *toP++ = *fromP++;",
"  }",
"  *toP = 0;",
"  return qline$;",
"}",
"",
"int main(int argc, char **argv) {",
"  int *returnP;",
"  int returna[10000];",
"  int *forP;",
"  int fora[10000];",
"",
"  returnP = returna;",
"  forP = fora;",
"",
"  for (i=0; i<256; i++) {",
"    chrs$[i][0] = i;",
"    chrs$[i][1] = 0;",
"  }",
"",
"/* bug = fopen(\"bug.bas\", \"w\"); */",
"",
"  if (argc==1) {",
"    printf(\"urbane infile -o=outfile\\n\");",
"    printf(\"-v verbose\\n\");",
"    printf(\"-l listing\\n\");",
"    printf(\"-o=outfile\\n\");",
"    printf(\"-l=listfile\\n\");",
"    printf(\"-e errorfile\\n\");",
"    printf(\"-x=xref\\n\");",
"  }",
"~",
  };

  i=0;
  while (between[i][0]!='~') {
    j = 0;
    while (between[i][j])  fputc(between[i][j++], outfile);
    fputc('\n', outfile);
    i++;
  }

  /* skip constants */

  fclose(infile);
  infile = fopen(filename, "r");
  linenumber = 0;
  intch = fgetc(infile);
  while (intch!=EOF) {
    linenumber++;
    eol = 0;
    charP = line;
    while (!eol) {
      if (intch==EOF || intch=='\r' || intch=='\n') {
        eol = 1;
        *charP = 0;
        if (intch=='\r') {
          intch = fgetc(infile);
          if (intch=='\n')  intch=fgetc(infile);
        }
        else if (intch=='\n')  intch=fgetc(infile);
      }
      else if (intch=='\"') {
        do {
          *charP++ = intch;
          intch = fgetc(infile);
        }
        while (intch!=EOF && intch!='\r' && intch!='\n' && intch!='\"');
        if (intch=='\"') {
          *charP++ = intch;
          intch = fgetc(infile);
        }
      }
      else if (intch==' ' || intch=='\t') {
        *charP++ = ' ';
        do {
          intch = fgetc(infile);
        }
        while (intch==' ' || intch=='\t');
      }
      else {
        *charP++ = intch;
        intch = fgetc(infile);
      }
    }
    if (!strcmp(line, "# CONSTANT UBN_XRF_KEYWORD_REFERENCE = 8"))  break;
  }

  /* do code */

  fputc('\n', outfile);
  labeling = 0;
  returns = 0;
  fors = 0;
  while (intch!=EOF) {
    linenumber++;
    eol = 0;
    charP = line;
    while (!eol) {
      if (intch==EOF || intch=='\r' || intch=='\n') {
        eol = 1;
        *charP = 0;
        if (intch=='\r') {
          intch = fgetc(infile);
          if (intch=='\n')  intch=fgetc(infile);
        }
        else if (intch=='\n')  intch=fgetc(infile);
      }
      else if (intch=='\"') {
        do {
          *charP++ = intch;
          intch = fgetc(infile);
        }
        while (intch!=EOF && intch!='\r' && intch!='\n' && intch!='\"');
        if (intch=='\"') {
          *charP++ = intch;
          intch = fgetc(infile);
        }
      }
      else if (intch==' ' || intch=='\t') {
        *charP++ = ' ';
        do {
          intch = fgetc(infile);
        }
        while (intch==' ' || intch=='\t');
      }
      else {
        *charP++ = intch;
        intch = fgetc(infile);
      }
    }
    word1[0] = 0;
    lineP = line;
    fromP = line;
    toP = qline;
    quote = 0;
    while (*fromP) {
      if (*fromP=='"')   quote = 1;
      if (*fromP=='"' || *fromP=='\\')  *toP++ = '\\';
      if (*fromP=='\\')   quote = 0;
      *toP++ = *fromP++;
    }
    *toP = 0;
    if (listing)  printf("%d %s\n", linenumber, line);
    if (!strcmp(line+1, " Add existing 2ch variable to output string"))
      fprintf(outfile, "havevariable() ;\n");
    if (!strcmp(line+1, " Skip blanks"))
      fprintf(outfile, "havechar() ;\n");
    if (line[0]=='\'')  fprintf(outfile, "  /*%s */", line+1);
    else {
      if ((line[0]>='A' && line[0]<='Z') || line[0]=='_') {
        labeling++;
        lineP = getword(word3, lineP);
        if (!strcmp(word3, "COLUMN_ONE") || !strcmp(word3, "LOAD_KEYWORDS"))
          fprintf(outfile, "/*%s */\n", word3);
        else  fprintf(outfile, "%s:\n", word3);
        if (!strcmp(word3, "VLSTRING_ADD_LOWER_ALPHA"))
          fprintf(outfile, "  goto VLSTRING_ADD_UPPER_ALPHA ;\n");
        if (!strcmp(word3, "COLUMN_ONE")) {
          fprintf(outfile, "  nextline() ;\n");
          fprintf(outfile, "  IN_LINE_CH = ASC_TILDE ;\n");
        }
        if (!strcmp(word3, "HAVE_KEYWORD")) {
          fprintf(outfile, "  if (!strcmp(VLSTRING$, \"DATA\")) {\n");
          fprintf(outfile, "    join(1, OUTPUT_STRING$, OUTPUT_STRING$, ");
          fprintf(outfile, "\"DATA \") ;\n");
          fprintf(outfile, "    join(1, OUTPUT_STRING$, OUTPUT_STRING$, ");
          fprintf(outfile, "IN_LINE$+IN_LINE_CHAR_COUNTER) ;\n");
          fprintf(outfile, "    goto OUTPUT_LINE ;\n");
          fprintf(outfile, "  }\n");
          fprintf(outfile, "  havekeyword() ;\n");
        }
        if (!strcmp(word3, "HAVE_LINE_LABEL"))
          fprintf(outfile, "  havelabel() ;\n");
        if (!strcmp(word3, "ADD_NUMBER"))
          fprintf(outfile, "  havenumber() ;\n");
        fprintf(outfile, "  if (label)  ");
        fprintf(outfile, "fprintf(bug, \"\\n%d ", linenumber);
        fprintf(outfile, "\") ;\n  if (tron)  fprintf(bug, \"\\n\")");
        if (!strcmp(lineP, " REM || !*lineP"))  lineP = skip2colon(lineP);
        else  fprintf(outfile, " ;\n");
      }
      fprintf(outfile, "  if (tron)  fprintf(bug, \"\\n%d  %s\") ;\n",
         linenumber,  qline);
      if (*lineP==' ') {
        fputc(*lineP++, outfile);
        fputc(' ', outfile);
        oldlineP = NULL;
        while (*lineP) {
          charP = getword(word1, lineP);
          if (!strcmp(line, " IN_LINE_CH = ASC(IN_LINE_CH$)")) {
            fprintf(outfile, "if (label || tron)  fprintf(bug, ");
            fprintf(outfile, "\"  %cs\", IN_LINE_CH$) ;\n  ", '%');
          }
          if (!strcmp(line, " GOTO NEXT_VLSTRING_CH")) {
            fprintf(outfile, "\n  if (label || tron) fprintf(bug, ");
            fprintf(outfile, "\"  %cs\", VLSTRING$) ;\n  ", '%');
          }
          if (!strcmp(word1, "IF")) {
            fprintf(outfile, "  if (");
            getword(word2, charP);
            if (!strcmp(word2, "INSTR")) {
              for (i=0; i<7; i++)  charP = getword(word2, charP);
              fprintf(outfile, "instr(IN_LINE$, %s)", word2);
              for (i=0; i<4; i++)  charP = getword(word3, charP);
              lineP = charP;
            }
            else do {
              lineP = getphrase(phrase1, charP);
              if (!lineP)  return 0;
              lineP = getword(word1, lineP);
              lineP = getphrase(phrase2, lineP);
              if (!lineP)  return 0;
              if (!strcmp(phrase2, "\"\\\""))  copyword("\"\\\\\"", phrase2);
              if (!strcmp(word1, "="))  copyword("==", word1);
              if (!strcmp(word1, "<>"))  copyword("!=", word1);
              if (string)  fprintf(outfile, "strcmp(%s, %s) %s 0",
                  phrase1, phrase2, word1);
              else  fprintf(outfile, "%s %s %s", phrase1, word1, phrase2);
              charP = getword(word1, lineP);
              if (!strcmp(word1, "+") || !strcmp(word1, "-")) {
                lineP = getphrase(phrase1, charP);
                if (!lineP)  return 0;
                fprintf(outfile, " %s %s", word1, phrase1);
                charP = getword(word1, lineP);
              }
              if (!strcmp(word1, "AND"))  fprintf(outfile, " && ");
              if (!strcmp(word1, "OR"))  fprintf(outfile, " || ");
            }
            while (!strcmp(word1, "AND") || !strcmp(word1, "OR"));
            fprintf(outfile, " ) {");
            brace = 1;
            if (!strcmp(word1, "THEN"))  lineP = charP;
          }
          else if (!strcmp(word1, "GOTO")) {
            fprintf(outfile, "goto ");
            lineP = charP;
            lineP = copylabel(outfile, lineP);
            if (!lineP)  error("GOTO");
          }
          else if (!strcmp(word1, ":")) {
            fprintf(outfile, " ; ");
            lineP = charP;
          }
          else if (!strcmp(word1, "RETURN")) {
            fprintf(outfile, "goto returns");
            lineP = charP;
          }
          else if (!strcmp(word1, "GOSUB")) {
            fprintf(outfile, "*forP++ = -1; *returnP++ = %d ; goto ", returns);
            lineP = charP;
            lineP = copylabel(outfile, lineP);
            fprintf(outfile, " ;\nreturn%d:", returns++);
            if (*lineP) {
              fprintf(outfile, "\n  ");
              lineP = getword(word1, lineP);
              if (strcmp(word1, ":"))  error("not a colon");
            }
          }
          else if (!strcmp(word1, "REM")) {
            lineP = charP;
            if (*lineP) {
              fprintf(outfile, " /*%s */", lineP);
              fputc(10, outfile);
              *lineP = 0;
            }
          }
          else if (!strcmp(word1, "STOP")) {
            fprintf(outfile, "  ");
            fprintf(outfile, "return 0");
            lineP = charP;
          }
          else if (!strcmp(word1, "NEXT")) {
            lineP = charP;
            charP = getword(word2, charP);
            if (variable) {
              for (i=variable0; i<variables; i++)
                if (strcmp(word2, definedv[i]))  break;
              if (i>=variables)  error("next forvar");
              forvar = i;
              lineP = charP;
            }
            else  forvar = 0;
            fprintf(outfile, "forvar = %d; ", forvar);
            fprintf(outfile, "back = %d; ", returns);
            fprintf(outfile, "goto next;\n");
            fprintf(outfile, "return%d:", returns++);
            if (*lineP) {
              fprintf(outfile, "\n  ");
              lineP = getword(word1, lineP);
              if (strcmp(word1, ":"))  error("not a colon");
            }
          }
          else if (!strcmp(word1, "PRINT")) {
            charP = getword(word1, charP);
            if (!strcmp(word1, "#FILE_L")) {
              if (!strcmp(charP, ", \" MEM = \" ; MEM")) {
                fprintf(outfile, "/* %s */", line);
                skipsemi = 1;
                screenc--;
              }
              else if (!screenv[screenc][0])   error("eol screenv");
              else if (screenv[screenc][0]=='q')  fprintf(outfile,
                "  if (!quiet)  printf(\"%s) ;\n", screenv[screenc]+1);
              else if (screenv[screenc][0]=='l') {
                fprintf(outfile,
                  "  fprintf(file_l, \" %s) ;\n", screenv[screenc]+1);
                fprintf(outfile,
                  "  if (list)  printf(\" %s) ;\n", screenv[screenc]+1);
              }
              else {
                fprintf(outfile, "if (!list || !quiet) ");
                fprintf(outfile, "printf(\" %s) ;\n", screenv[screenc]);
                fprintf(outfile, "  fprintf(file_e, ");
                fprintf(outfile, "\" %s) ;\n", screenv[screenc]);
              }
              screenc++;
            }
            else if (!strcmp(word1, "#FILE_O")) {
              fprintf(outfile, "\n    if (VLSTRING_COUNT==1 && ");
              fprintf(outfile, "hasalabel)  join(1, OUTPUT_STRING$, ");
              fprintf(outfile, "OUTPUT_STRING$, \" REM\") ;\n");
              fprintf(outfile, "    fprintf(file_o, ");
              fprintf(outfile, "\"%cs\\n\", OUTPUT_STRING$) ;\n", '%');
              fprintf(outfile, "    qlineP$ = showquotes(OUTPUT_STRING$) ;\n");
              fprintf(outfile, "    if (echo)  fprintf(bug, ");
              fprintf(outfile, "\"\\n++++++ %cs\", qlineP$)", '%');
              fprintf(outfile, " ;\n  ");
              skipsemi = 1;
            }
            else if (!strcmp(word1, "#FILE_X")) {
              if (!xref[xrefc][0])   error("eol xref");
              else if (strcmp(xref[xrefc], "skip")){
                fprintf(outfile, "fprintf(file_x, ");
                fprintf(outfile, "\" %s)", xref[xrefc++]);
              }
            }
            else {
              if (lineP!=line+1) fprintf(outfile, " ; ");
              skipsemi = 1;
            }
            lineP = skip2colon(charP);
          }
          else if (!strcmp(word1, "FOR")) {
            if (!(charP = getphrase(phrase1, charP)))  error("FOR");
            if (string)  error("string for FOR index");
            charP = getword(word2, charP);
            if (!(charP = getphrase(phrase2, charP)))  error("FOR");
            if (string)  error("string for FOR index");
            charP = getword(word3, charP);
            if (!(charP = getphrase(phrase3, charP)))  error("FOR");
            if (string)  error("string for FOR index");
            if (strcmp(word2, "=") || strcmp(word3, "TO"))
              error("for syntax");
            for (i=variable0; i<variables; i++)
              if (strcmp(phrase1, definedv[i]))  break;
            if (i>=variables)  error("for forvar");
            fprintf(outfile, "*forP++ = %d; ", i);
            fprintf(outfile, "*returnP++ = %d;\n", returns);
            lineP = charP;
            fprintf(outfile, "  %s=%s; goto for%d;\n", phrase1, phrase2, fors);
            fprintf(outfile, "return%d:\n", returns++);
            fprintf(outfile, "  %s=%s+1; if (%s>%s) goto forgone;\n",
                phrase1, phrase1, phrase1, phrase3);
            fprintf(outfile, "for%d:", fors++);
            if (*lineP) {
              fprintf(outfile, "\n  ");
              lineP = getword(word1, lineP);
              printf("\n%s\n", word1);
              if (strcmp(word1, ":"))  error("not a colon");
            }
          }
          else if (!strcmp(word1, "LINE")) {
            fprintf(outfile, "input(IN_LINE$) ;\n");
            lineP = skip2colon(charP);
          }
          else if (!strcmp(word1, "ON")) {
            fprintf(outfile, "if (PASS==1) goto OUTPUT_LINE;");
            for (i=0; i<5; i++)  charP = getword(word2, charP);
            fprintf(outfile, " else goto %s;", word2);
            skipsemi = 1;
            lineP = charP;
          }
          else if (!strcmp(word1, "DIM") || !strcmp(word1, "DATA") ||
              !strcmp(word1, "FILES") || !strcmp(word1, "PCLEAR") ||
              !strcmp(word1, "CLEAR")) {
            fprintf(outfile, "/* %s */", word1);
            lineP = skip2colon(charP);
            skipsemi = 1;
          }
          else if (!strcmp(word1, "READ")) {
            lineP = getphrase(phrase1, charP);
            if (!lineP)  return error("READ");
            fprintf(outfile, "i = 0; ");
            fprintf(outfile, "while ((%s[i] = datav[datac][i]))", phrase1);
            fprintf(outfile, "  i++; datac++;");
            skipsemi = 1;
          }
          else if (!strcmp(word1, "LNR_$")) {
            fprintf(outfile, "let(0,LN_$,str$(LINE_NUMBER));\n");
            fprintf(outfile, "  goto returns");
            lineP = skip2colon(charP);
          }
          else if (!strcmp(word1, "CLOSE")) {
            lineP = getword(word2, charP);
            if (!strcmp(word2, "FILE_I") || !strcmp(word2, "NUM_1"))
              copyword("file_i", word2);
            else if (!strcmp(word2, "FILE_O") || !strcmp(word2, "NUM_2"))
              copyword("file_o", word2);
            else if (!strcmp(word2, "FILE_X")) {
/*            fprintf(outfile, "  if(!ERRORS && !WARNINGS && quiet)  "); */
/*            fprintf(outfile, "printf(\"[no errors]\\n\") ;\n"); */
            }
            else {
              skipsemi = 1;
            }
            if (!strcmp(word2, "file_i") || !strcmp(word2, "file_o"))
              fprintf(outfile, "fclose(%s)", word2);
          }
          else if (!strcmp(word1, "OPEN")) {
            for (i=0; i<3; i++)  charP = getword(word2, charP);
            if (!strcmp(word2, "#NUM_1")) {
              fprintf(outfile, "parse(argc, argv) ;\n");
              fprintf(outfile, "  file_i = fopen(argv[1], \"r\") ;\n");
              fprintf(outfile, "  intchar = fgetc(file_i) ;\n");
              fprintf(outfile, "  eof = 0" );
            }
            else if (!strcmp(word2, "#NUM_2"))
              fprintf(outfile, "file_o = fopen(fileoutname, \"w\")");
            else  {
              skipsemi = 1;
            }
            lineP = skip2colon(charP);
          }
          else if (!strcmp(word1, "END")) {
            fprintf(outfile, "if (errors && (ERRORS || WARNINGS)) {\n");
            fprintf(outfile, "    fclose(file_o);\n");
            fprintf(outfile, "    file_o = fopen(fileoutname, \"w\");\n");
            fprintf(outfile, "    fclose(file_e);\n");
            fprintf(outfile, "    file_e = fopen(\"errors.txt\", \"r\");\n");
            fprintf(outfile, "    intch = fgetc(file_e);\n");
            fprintf(outfile, "    while (intch!=EOF) {\n");
            fprintf(outfile, "      fputc(intch, file_o);\n");
            fprintf(outfile, "      intch = fgetc(file_e);\n");
            fprintf(outfile, "    }\n");
            fprintf(outfile, "  }\n");
            fprintf(outfile, "  return 0");
            lineP = skip2colon(lineP);
          }
          else if (!strcmp(line, " I_EOF = EOF(FILE_I)")) {
            fprintf(outfile, "  qlineP$ = showquotes(IN_LINE$) ;\n");
            fprintf(outfile, "  if (label || tron)  fprintf(bug, \"\\n\") ;\n");
            fprintf(outfile, "  if (echo)  fprintf(bug, ");
            fprintf(outfile, "\"\\n****** %cd %cs\", LINE_NUMBER, qlineP$) ;\n",
                '%', '%');
            fprintf(outfile, "  if (PASS==2 && !strcmp(IN_LINE$, \"tron\"))");
            fprintf(outfile, "  tron = 1 ;\n");
            fprintf(outfile, "  if (PASS==2 && !strcmp(IN_LINE$, \"label\"))");
            fprintf(outfile, "  label = 1 ;\n");
            fprintf(outfile, "  if (PASS==2 && !strcmp(IN_LINE$, \"debug\"))");
            fprintf(outfile, "  debug = 1 ;\n");
            fprintf(outfile, "  if ((PASS==2 && !strcmp(IN_LINE$, \"echo\"))");
            fprintf(outfile, " || label || tron)  echo = 1 ;\n");
            fprintf(outfile, "  if (PASS==2 && !strcmp(IN_LINE$, \"exit\"))");
            fprintf(outfile, "  exit(0) ;\n");
            fprintf(outfile, "  I_EOF = eof");
            lineP = skip2colon(line);
          }
          else if (!strcmp(line, " "))  skipsemi = 1;
          else {
            charP = getphrase(phrase1, lineP);
            if (!charP)  return 0;
            if (string) {
              charP = getword(word2, charP);
              getword(word3, charP);
              if (!strcmp(word3, "LEFT$")) {
                fprintf(outfile, "QSTRING$[QSTRING_LENGTH] = 0");
                charP = skip2colon(charP);
              }
              else {
                charP = getphrase(phrase2, charP);
                if (!charP) return 0;
                if (!string)  error("string mismatch");
                getword(word3, charP);
                if (!strcmp(word2, "=") && strcmp(word3, "+")) {
                  fprintf(outfile, "if (let(%d, ", linenumber);
                  fprintf(outfile, "%s, %s))  return 0", phrase1, phrase2);
                }
                else if (!strcmp(word2, "=") && !strcmp(word3, "+")) {
                  charP = getword(word3, charP);
                  charP = getphrase(phrase3, charP);
                  if (!string)  error("string mismatch");
                  fprintf(outfile, "if (join(%d, %s, %s, %s)) return 0",
                      linenumber, phrase1, phrase2, phrase3);
                }
                else error("string 1");
              }
              lineP = charP;
            }
            else {
              charP = getword(word2, charP);
              if (!strcmp(word2, "=")) {
                charP = getphrase(phrase2, charP);
                if (!charP)  return 0;
                fprintf(outfile, "%s = %s", phrase1, phrase2);
                if (string)  error("mismatch");
                lineP = charP;
                charP = getword(word2, charP);
                parens = 0;
                while (!strcmp(word2, "+") || !strcmp(word2, "-") ||
                    !strcmp(word2, "*") || !strcmp(word2, "/") ||
                    !strcmp(word2, "(") || !strcmp(word2, ")")) {
                  fprintf(outfile, " %s", word2);
                  lineP = charP;
                  charP = getword(word2, lineP);
                  if (!strcmp(word2, "(")) {
                    parens++;
                    fprintf(outfile, " (");
                    lineP = charP;
                  }
                  charP = getphrase(phrase3, lineP);
                  if (!charP)  return 0;
                  if (string)  error("string mismatch");
                  fprintf(outfile, " %s", phrase3);
                  lineP = charP;
                  charP = getword(word2, charP);
                  if (!strcmp(word2, ")")) {
                    parens--;
                    fprintf(outfile, " )");
                    lineP = charP;
                    charP = getword(word2, lineP);
                  }
                }
                if (parens)  error("parens");
              }
            }
          }
          if (lineP==oldlineP) {
            printf("%d %s", linenumber, line);
            return 0;
          }
          oldlineP = lineP;
        }
        if (!(!strcmp(word1, "REM") || skipsemi ||
             !strcmp(word1, "FOR") || !strcmp(word1, "GOSUB")))
          fprintf(outfile, " ;");
        skipsemi = 0;
        if (brace)  fprintf(outfile, "}");
        brace = 0;
      }
    }
    if (strcmp(word1, "REM")) {
      fputc(10, outfile);
    }
  }
  fputc(10, outfile);

  char *last[] = {
"",
"next:",
"  while (1) {",
"    if (*(forP-1)==forvar) break;",
"    if (*(forP-1)<0)  return error(\"next without for\");",
"    if (forvar==0)  break;",
"    forP--;",
"    returnP--;",
"    if (forP==fora)  return error(\"next without for\");",
"  }",
"  switcher = *(returnP-1);",
"  goto switching;",
"",
"forgone:",
"  forP--; returnP--; switcher=back; goto switching;",
"",
"returns:",
"  if (debug) fprintf(bug, \"\\n%d   %d\", forP-fora, *returnP);",
"/* return - fors %d, returns %d, *forP %d, *returnP %d\\n, */",
"/* forP-fora, returnP-returna, *(forP-1), *(returnP-1)); */",
"  if (forP<=fora) {",
"    for (tempP=returnP; tempP<returnP+20; tempP++)",
"      printf(\"\\n%d\", *tempP);",
"    return error(\"return without gosub===\");",
"  }",
"  while (forP>fora) {",
"    forP--;",
"    returnP--;",
"    if (*forP<0) break;",
"  }",
"  if (debug) fprintf(bug, \"\\n%d   %d\", forP-fora, *returnP);",
"  if(*forP>=0) {",
"    for (tempP=forP; tempP<forP+20; tempP++)",
"      printf(\"%d\\n\", *tempP);",
"    return error(\"return without gosub\");",
"  }",
"  switcher = *returnP;",
"  goto switching;",
"",
"switching:",
"  switch(switcher) {",
"~",
  };

  i=0;
  while (last[i][0]!='~') {
    j = 0;
    while (last[i][j])  fputc(last[i][j++], outfile);
    fputc('\n', outfile);
    i++;
  }

  for (i=0; i<returns; i++) {
    fprintf(outfile, "    case %d: goto return%d;\n", i, i);
  }

  fprintf(outfile, "  }\n  return 0;\n}\n");
  fclose(outfile);
  return 0;
}
